diff --git a/web/setup.py b/web/setup.py
index 14bd5f9cc..0532d720b 100644
--- a/web/setup.py
+++ b/web/setup.py
@@ -231,18 +231,22 @@ def load_servers(args):
 
             check_attrib("Name")
             check_attrib("Group")
-            check_attrib("Port")
-            check_attrib("Username")
+
+            if "Service" not in obj:
+                check_attrib("Port")
+                check_attrib("Username")
+
             check_attrib("SSLMode")
             check_attrib("MaintenanceDB")
 
-            if "Host" not in obj and \
-                "HostAddr" not in obj and \
-                    "Service" not in obj:
-                print("'Host', 'HostAddr' or 'Service' attribute not found "
-                      "for server '%s'" % server)
-                print_summary()
-                sys.exit(1)
+            is_service_attrib_available = True if "Service" in obj else False;
+
+            if "Host" not in obj and "HostAddr" not in obj:
+                if is_service_attrib_available is False:
+                    print("'Host', 'HostAddr' or 'Service' attribute not found "
+                          "for server '%s'" % server)
+                    print_summary()
+                    sys.exit(1)
 
             # Get the group. Create if necessary
             group_id = -1
@@ -275,20 +279,24 @@ def load_servers(args):
             new_server.servergroup_id = group_id
             new_server.user_id = user_id
 
-            new_server.host = obj["Host"]
+            new_server.ssl_mode = obj["SSLMode"]
+            new_server.maintenance_db = obj["MaintenanceDB"]
+
+            if "Host" in obj:
+                new_server.host = obj["Host"]
 
             if "HostAddr" in obj:
                 new_server.hostaddr = obj["HostAddr"]
 
-            new_server.port = obj["Port"]
-            new_server.maintenance_db = obj["MaintenanceDB"]
-            new_server.username = obj["Username"]
+            if "Port" in obj:
+                new_server.port = obj["Port"]
+
+            if "Username" in obj:
+                new_server.username = obj["Username"]
 
             if "Role" in obj:
                 new_server.role = obj["Role"]
 
-            new_server.ssl_mode = obj["SSLMode"]
-
             if "Comment" in obj:
                 new_server.comment = obj["Comment"]
 
